#property copyright "Copyright  2014 - Alguasta Software"
#property link      ""
#property strict

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_color7 Red
#property indicator_color8 Aqua
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

enum tfs {M1=1,M5=5,M15=15,M30=30,H1=60,H4=240,D1=1440,W1=10080,MN=43200};
enum trs {Conservative=1,Normal=2,Aggresive=3};
enum ooo {Off=0,On=1};
#define OFF 0
#define ON 1

extern bool Master = true;
extern trs Trend_Speed = 2;
extern tfs HigherTrendPeriod=60;
extern ooo Pull_in_Stop = OFF;
extern int Pull_in_Count = 15;
extern trs Pull_in_Stop_to = 2;
extern ooo Stops = ON;
extern ooo Trend = ON;
extern ooo Pivots = ON;
extern ooo WideBars = ON;
extern ooo Progress = ON;
extern ooo NextBarTime = ON;
extern int NextBarTimeOffset = 240;    // Offset timer from bar
extern ooo Trend_Alerts = OFF;
extern ooo Stop_Alerts = OFF;
extern ooo Sessions = ON;
extern ooo SupportResistance = ON;
extern ooo HighLows = OFF;
extern int LoopInterval = 10;
extern ooo LoopSound = OFF;
extern string SessionNames  = "Asia/Euro/USA/";
extern string SessionBegins = "00:00/08:00/13:00/"; 
extern string SessionEnds   = "07:00/16:00/21:00/"; 
extern color  color1        = C'5,55,6'; 
extern color  color2        = C'5,35,56'; 
extern color  color3        = C'65,5,46'; 
extern color  color4        = C'5,25,34'; 
extern color  color5        = C'25,65,5'; 
extern bool   FillColor     = true;
extern int    FrameWidth    = 1; 
extern int    FrameStyle    = 1; 
extern int    LabelSize     = 8;
extern string LabelFont     = "Arial Bold";
extern color  LabelColor    = DarkKhaki;
extern bool Use_Sunday_Data = FALSE;
extern bool Daily = TRUE;
extern bool Daily_SR_Levels = TRUE;
extern bool Daily_Mid_Levels = FALSE;
extern bool Weekly = FALSE;
extern bool Weekly_SR_Levels = FALSE;
extern bool Weekly_Mid_Levels = FALSE;
extern bool Monthly = FALSE;
extern bool Monthly_SR_Levels = FALSE;
extern bool Monthly_Mid_Levels = FALSE;
extern color Daily_Pivot = Fuchsia;
extern color Daily_S_Levels = LimeGreen;
extern color Daily_R_Levels = Red;
extern color Daily_Mid_Level = LightSalmon;
extern color Weekly_Pivot = Aqua;
extern color Weekly_S_Levels = SteelBlue;
extern color Weekly_R_Levels = Peru;
extern color Weekly_Mid_Level = LightPink;
extern color Monthly_Pivot = Gray;
extern color Monthly_S_Levels = Orange;
extern color Monthly_R_Levels = Blue;
extern color Monthly_Mid_Level = LightSalmon;

#import "SDSMain.dll"
   int xCreateFunc2012();
   int xDestroyFunc2012(int a0);
   void SDSAddPriceData(int a0, double a1, double a2, double a3, double a4, int a5, int a6, int a7, int a8, int a9, double a10, int a11);
   int SDSHSB(int a0, int a1, double a2, double a3, double a4);
   double SDSHSBFSV(int a0, int a1, double a2, double a3, double a4);
   double SDSHSBV(int a0, int a1, double a2, double a3, double a4);
   double SDSHTV(int a0, int a1);
   int SDSHT(int a0, int a1, double a2);
   int SDSHV(int a0, int a1);
   int SDSHWB(int a0, int a1);
   int SDSHISHL(int a0, int a1);
#import

#import "user32.dll"
int GetForegroundWindow();
int FindWindowExW(int,int,string,string);
int GetWindowRect(int,int &arr[]);
int GetClientRect(int,int &arr[]);
int SetWindowLongW(int,int,int);
int SetWindowLongPtr(int,int,int);
int GetWindowLongW(int,int);
int GetSystemMenu(int,bool);
int InsertMenuW(int,int,int,int,string);
int SetWindowPos(int,int,int,int,int,int,int);
int GetParent(int);
int GetWindowTextW(int,short &arr[],int);
int ShowWindow(int,int);
int GetClassNameW(int,short &arr[],int);
int GetDlgCtrlID(int);
int GetDlgItem(int,int);
bool IsZoomed(int);
bool InvalidateRect(int,int &arr[],bool);
#import

#define GWL_STYLE         -16 
#define WS_SIZEBOX        0x00040000
#define WS_MINIMIZEBOX    0x00020000
#define WS_MAXIMIZEBOX    0x00010000
#define WS_CAPTION        0x00C00000
#define WS_THICKFRAME     0x00040000
#define WS_SYSMENU        0x00080000
#define WS_MAXIMIZE       0x01000000
#define WS_MINIMIZE       0x20000000
#define WS_DLGFRAME       0x00400000
#define WS_POPUP          0x80000000
#define WS_CHILD          0x40000000
#define WS_THINFRAME      0x00100000
#define MF_STRING         0x00000000
#define MF_BYPOSITION     0x00000400
#define SW_MAXIMIZE       0x0003
#define SC_SIZE           0xF000
#define SC_MAXIMIZE       0xF030
#define SC_MINIMIZE       0xF020
#define SC_RESTORE        0xF120
#define SWP_NOSIZE        0x0001
#define SWP_NOMOVE        0x0002
#define SWP_NOZORDER      0x0004
#define SWP_NOACTIVATE    0x0010
#define SWP_FRAMECHANGED  0x0020

string buttonID="Button";
int broadcastEventID=5000;
string lastsymbol;

double G_ibuf_136[];
double G_ibuf_140[];
double G_ibuf_144[];
double G_ibuf_148[];
double G_ibuf_152[];
double G_ibuf_156[];
double G_ibuf_160[];
double G_ibuf_164[];

int Gi_164;
int Gi_100;
string Gs_168;
double Gd_176;
datetime lastbar, lastmtfbar;
int objectcolor;
int objectwidth;

double trendspeed = 1.625;
double trendmodifier = 2.25;

int timeframedivider;

string sTIME_BEGIN = "1970.01.01", saName[], saBeg[], saEnd[];
datetime t0, curDate, lastDate[], t1[], t2[];
double lo[], hi[], vPoint;
int col[5] = {0,0,0,0,0};
int pip[], pipRange, Qty;

double Gd_164;
double Gd_172;
double Gd_180;
double Gda_188[][6];
double G_price_192;
double G_price_200;
double G_price_208;
double G_price_216;
double G_price_224;
double G_price_232;
double G_price_240;
double G_price_248;
double G_price_256;
double G_price_264;
double G_price_272;
double G_price_280;
double G_price_288;
double Gd_296;
double Gd_304;
double Gd_312;
double Gda_320[][6];
double G_price_324;
double G_price_332;
double G_price_340;
double G_price_348;
double G_price_356;
double G_price_364;
double G_price_372;
double G_price_380;
double G_price_388;
double G_price_396;
double G_price_404;
double G_price_412;
double G_price_420;
double Gd_428;
double Gd_436;
double Gd_444;
double Gda_452[][6];
double G_price_456;
double G_price_464;
double G_price_472;
double G_price_480;
double G_price_488;
double G_price_496;
double G_price_504;
double G_price_512;
double G_price_520;
double G_price_528;
double G_price_536;
double G_price_544;
double G_price_552;
string pairnames[29]={ "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","CADCHF","CADJPY",
                       "CHFJPY","EURAUD","EURCAD","EURCHF","EURGBP","EURJPY",
                       "EURNZD","EURUSD","GBPAUD","GBPCAD","GBPCHF",
                       "GBPJPY","GBPNZD","GBPUSD","NZDCAD",
                       "NZDCHF","NZDJPY","NZDUSD","USDCAD",
                       "USDCHF","USDJPY","XAUUSD" };

int but[9]={1,5,15,30,60,240,1440,10080,43200};
string butname[9]={"M1","M5","M15","M30","H1","H4","D1","W1","MN"};

int init() {

   resizeWindow();   

   SetIndexShift(0, 0);
   SetIndexShift(1, 0);
   SetIndexShift(2, 0);
   SetIndexShift(3, 0);
   SetIndexShift(4, 0);
   SetIndexShift(5, 0);
   SetIndexShift(6, 0);
   SetIndexShift(7, 0);
   SetIndexDrawBegin(0, 0);
   SetIndexDrawBegin(1, 0);
   SetIndexDrawBegin(2, 0);
   SetIndexDrawBegin(3, 0);
   SetIndexDrawBegin(4, 0);
   SetIndexDrawBegin(5, 0);
   SetIndexDrawBegin(6, 0);
   SetIndexDrawBegin(7, 0);
   SetIndexBuffer(0, G_ibuf_136);
   SetIndexBuffer(1, G_ibuf_140);
   SetIndexBuffer(2, G_ibuf_144);
   SetIndexBuffer(3, G_ibuf_148);
   SetIndexBuffer(4, G_ibuf_152);
   SetIndexBuffer(5, G_ibuf_156);
   SetIndexBuffer(6, G_ibuf_160);
   SetIndexBuffer(7, G_ibuf_164);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 108);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 108);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 108);
   SetIndexStyle(3, DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(4, DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(7, DRAW_ARROW);
   SetIndexArrow(7, 161);
   SetIndexLabel(0, "Trend");
   SetIndexLabel(1, "Trend");
   SetIndexLabel(2, "Trend");
   SetIndexLabel(3, "FarStop");
   SetIndexLabel(4, "FarStop");
   SetIndexLabel(5, "HigherStop");
   SetIndexLabel(6, "HigherStop");
   SetIndexLabel(7, "Progress");

   switch (Period()) {
   case PERIOD_M1:
      Gs_168 = "1 min";
      break;
   case PERIOD_M5:
      Gs_168 = "5 mins";
      break;
   case PERIOD_M15:
      Gs_168 = "15 mins";
      break;
   case PERIOD_M30:
      Gs_168 = "30 mins";
      break;
   case PERIOD_H1:
      Gs_168 = "1 hour";
      break;
   case PERIOD_H4:
      Gs_168 = "4 hours";
      break;
   case PERIOD_D1:
      Gs_168 = "Daily";
      break;
   case PERIOD_W1:
      Gs_168 = "Weekly";
      break;
   case PERIOD_MN1:
      Gs_168 = "Monthly";
   }

   switch (Trend_Speed) {
      case 1:
         trendspeed = 2.0;
         trendmodifier = 2.5;
      break;
      case 2:
         trendspeed = 1.625;
         trendmodifier = 2.25;
      break;
      case 3:
         trendspeed = 1.25;
         trendmodifier = 2.25;
      break;    
   }

   timeframedivider = HigherTrendPeriod / Period();

   if (Sessions == ON)
      sessionInit();

   if (SupportResistance == ON)
      supresInit();

   if (NextBarTime == ON)
      ObjectCreate("BarTime",OBJ_TEXT,0,0,0);

   Gi_164 = xCreateFunc2012();
   Gi_100 = xCreateFunc2012();

   lastsymbol = Symbol();
/*
   if (Master == true) {
   ObjectCreate(0,buttonID,OBJ_LABEL,0,100,100);
   ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,200);
   ObjectSetInteger(0,buttonID,OBJPROP_ARROWCODE,OBJ_ARROW_STOP);
   ObjectSetInteger(0,buttonID,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
   ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,10);
   ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,100);
   ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,30);
   ObjectSetString(0,buttonID,OBJPROP_FONT,"Arial");
   if (GlobalVariableGet("state") == 1) {
//      ObjectSetInteger(0,buttonID,OBJPROP_STATE,1);
//      ObjectSetString(0,buttonID,OBJPROP_TEXT,"Stop Loop");
//      EventSetTimer(LoopInterval);
   ObjectSetInteger(0,buttonID,OBJPROP_COLOR,clrWhite);
   ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,clrRed);
   }
   else { 
//      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,clrWhite);
//      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,clrGreen);
//      ObjectSetString(0,buttonID,OBJPROP_TEXT,"Start Loop");
   }
   ObjectSetInteger(0,buttonID,OBJPROP_BACK,0);
   ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,12);
   ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
   }
*/
   for (int i=0;i<15;i++) {
      ObjectCreate(0,pairnames[i],OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_XSIZE,50);
      ObjectSetInteger(0,pairnames[i],OBJPROP_YSIZE,15);
      if (pairnames[i] == Symbol())
         ObjectSetInteger(0,pairnames[i],OBJPROP_BGCOLOR,clrBlue);
      else
         ObjectSetInteger(0,pairnames[i],OBJPROP_BGCOLOR,clrDarkGreen);
      ObjectSetInteger(0,pairnames[i],OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,pairnames[i],OBJPROP_YDISTANCE,10);
      ObjectSetInteger(0,pairnames[i],OBJPROP_XDISTANCE,100 + i*55);
      ObjectSetString(0,pairnames[i],OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,pairnames[i],OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,pairnames[i],OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,pairnames[i],OBJPROP_TEXT,pairnames[i]);
      ObjectSetInteger(0,pairnames[i],OBJPROP_BACK,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_STATE,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_SELECTABLE,0);
   }
   for (int i=15;i<29;i++) {
      ObjectCreate(0,pairnames[i],OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_XSIZE,50);
      ObjectSetInteger(0,pairnames[i],OBJPROP_YSIZE,15);
      if (pairnames[i] == Symbol())
         ObjectSetInteger(0,pairnames[i],OBJPROP_BGCOLOR,clrBlue);
      else
         ObjectSetInteger(0,pairnames[i],OBJPROP_BGCOLOR,clrDarkGreen);
      ObjectSetInteger(0,pairnames[i],OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,pairnames[i],OBJPROP_YDISTANCE,30);
      ObjectSetInteger(0,pairnames[i],OBJPROP_XDISTANCE,100 + (i-15)*55);
      ObjectSetString(0,pairnames[i],OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,pairnames[i],OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,pairnames[i],OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,pairnames[i],OBJPROP_TEXT,pairnames[i]);
      ObjectSetInteger(0,pairnames[i],OBJPROP_BACK,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_STATE,0);
      ObjectSetInteger(0,pairnames[i],OBJPROP_SELECTABLE,0);
   }
      ObjectCreate(0,"cclose",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,"cclose",OBJPROP_XSIZE,50);
      ObjectSetInteger(0,"cclose",OBJPROP_YSIZE,15);
      ObjectSetInteger(0,"cclose",OBJPROP_BGCOLOR,clrRed);
      ObjectSetInteger(0,"cclose",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,"cclose",OBJPROP_YDISTANCE,30);
      ObjectSetInteger(0,"cclose",OBJPROP_XDISTANCE,870);
      ObjectSetString(0,"cclose",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"cclose",OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,"cclose",OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,"cclose",OBJPROP_TEXT,"Close");
      ObjectSetInteger(0,"cclose",OBJPROP_BACK,0);
      ObjectSetInteger(0,"cclose",OBJPROP_STATE,0);
      ObjectSetInteger(0,"cclose",OBJPROP_SELECTABLE,0);

   for(int i=0;i<9;i++) {
   ObjectCreate(0,butname[i],OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,butname[i],OBJPROP_XSIZE,25);
   ObjectSetInteger(0,butname[i],OBJPROP_YSIZE,15);
   if (Period() == but[i])
      ObjectSetInteger(0,butname[i],OBJPROP_BGCOLOR,clrBlue);
   else
      ObjectSetInteger(0,butname[i],OBJPROP_BGCOLOR,clrGray);
   ObjectSetInteger(0,butname[i],OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
   ObjectSetInteger(0,butname[i],OBJPROP_YDISTANCE,50);
   ObjectSetInteger(0,butname[i],OBJPROP_XDISTANCE,100 + i * 30);
   ObjectSetString(0,butname[i],OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,butname[i],OBJPROP_FONTSIZE,8);
   ObjectSetInteger(0,butname[i],OBJPROP_COLOR,clrWhite);
   ObjectSetString(0,butname[i],OBJPROP_TEXT,butname[i]);
   ObjectSetInteger(0,butname[i],OBJPROP_BACK,0);
   ObjectSetInteger(0,butname[i],OBJPROP_STATE,0);
   ObjectSetInteger(0,butname[i],OBJPROP_SELECTABLE,0);
   }

   return (0);
}

int deinit() {
   xDestroyFunc2012(Gi_164);
   xDestroyFunc2012(Gi_100);
   ObjectsDeleteAll(0,OBJ_RECTANGLE);
   ObjectsDeleteAll(0,OBJ_ARROW);
   if (Sessions == ON)
      sessionDeinit();

   if (SupportResistance == ON)
      supresDeinit();

   return (0);
}

int start() {

   if (NextBarTime == ON)
      nextBar();

   if (Sessions == ON)
      sessionStart();

   if (Time[0] == lastbar)
      return(0);
      
   lastbar = Time[0];

   if (SupportResistance == ON)
      supresStart();

   int G_count_112;
   int G_count_116;
   int G_count_120;

   int Li_0;
   double Ld_20;
   double Ld_28;
   double Ld_36;
   double Ld_44;
   double Ld_52;
   double Ld_60;
   double Ld_68;
   int Li_76;
   int Li_84;
   double Ld_88;
   double Ld_96;
   int Li_104;
   int Li_4;
   int Li_6;
   int Li_8;
   int Li_10;


   if (AccountNumber() > 0) {
      Li_0 = AccountNumber();
      if (Li_0 > 99999999) Li_0 -= 100000000 * (Li_0 / 100000000);
      Ld_68 = 2;
      Li_76 = Bars - IndicatorCounted();
      if (Li_76 > 200)
         Li_76 = 200;
      for (int Li_80 = Li_76; Li_80 > 0; Li_80--) {
         SDSAddPriceData(Gi_164, Open[Li_80], High[Li_80], Low[Li_80], Close[Li_80], Volume[Li_80], Time[Li_80], Period(), Period(), 2, Point, 200 - Li_80);
         if (Stops == ON) {
            Ld_20 = SDSHSB(Gi_164, Li_0, trendspeed, trendmodifier, trendspeed);
            Ld_52 = SDSHSBFSV(Gi_164, Li_0, trendspeed, trendmodifier, trendspeed);
            if (Pull_in_Stop_to == 3) Ld_68 = 1.25;
            if (Pull_in_Stop_to == 2) Ld_68 = 1.625;
            Ld_60 = SDSHSBFSV(Gi_164, Li_0, Ld_68, trendmodifier, 2.0);
            if (Ld_20 != Gd_176) {
               Ld_28 = 0;
               Ld_36 = 0;
               Ld_44 = 0;
            }
            Ld_28 += 1.0;
            Li_84 = SDSHSB(Gi_164, Li_0, Ld_68, trendmodifier, Ld_68);
            if (Pull_in_Stop == ON || trendspeed == 2.0 || trendspeed == 1.625) {
               if (Ld_20 == 1.0) {
                  if (Ld_28 >= Pull_in_Count && Li_84 == 1) Ld_36 = 1;
                  if (Ld_36 == 1.0) G_ibuf_148[Li_80] = Ld_60;
                  if (Ld_36 == 0.0) G_ibuf_148[Li_80] = Ld_52;
               }
               if (Ld_20 == -1.0) {
                  if (Ld_28 >= Pull_in_Count && Li_84 == -1) Ld_44 = 1;
                  if (Ld_44 == 1.0) G_ibuf_152[Li_80] = Ld_60;
                  if (Ld_44 == 0.0) G_ibuf_152[Li_80] = Ld_52;
               }
            } else {
               if (Ld_20 == 1.0) G_ibuf_148[Li_80] = Ld_52;
               if (Ld_20 == -1.0) G_ibuf_152[Li_80] = Ld_52;
            }
//            Ld_88 = SDSHSBV(Gi_164, Li_0, trendspeed, trendmodifier, trendspeed);
//            if (Ld_20 == 1.0) G_ibuf_156[Li_80] = Ld_88;
//            if (Ld_20 == -1.0) G_ibuf_160[Li_80] = Ld_88;
         }
         if (Trend == ON) {
            Ld_96 = SDSHTV(Gi_164, Li_0);
            Li_104 = SDSHT(Gi_164, Li_0, trendspeed);
            if (Progress == ON) {         
               if (Li_104 == 0) {
                  G_count_112++;
                  G_count_116 = 0;
                  G_count_120 = 0;
               }
               if (Li_104 == 1) {
                  G_count_112 = 0;
                  G_count_116 = 0;
                  G_count_120++;
               }
               if (Li_104 == -1) {
                  G_count_112 = 0;
                  G_count_116++;
                  G_count_120 = 0;
               }
               if (G_count_112 == 8 || G_count_116 == 8 || G_count_120 == 8) {
                  if (Li_80 > 0)
                     G_ibuf_164[Li_80] = Ld_96;
                     G_count_112 = 0;
                     G_count_116 = 0;
                     G_count_120 = 0;
                  } else {
                     G_ibuf_164[Li_80] = EMPTY_VALUE;
               }
            }
            if (Li_104 == 1) {
               G_ibuf_136[Li_80] = Ld_96;
               G_ibuf_140[Li_80] = EMPTY_VALUE;
               G_ibuf_144[Li_80] = EMPTY_VALUE;
            } else {
               if (Li_104 == -1) {
                  G_ibuf_136[Li_80] = EMPTY_VALUE;
                  G_ibuf_140[Li_80] = Ld_96;
                  G_ibuf_144[Li_80] = EMPTY_VALUE;
               } else {
                  if (Li_104 == 0) {
                     G_ibuf_136[Li_80] = EMPTY_VALUE;
                     G_ibuf_140[Li_80] = EMPTY_VALUE;
                     G_ibuf_144[Li_80] = Ld_96;
                  }
               }
            }
         }
         Gd_176 = Ld_20;

         if (Pivots == ON) {
            if (ObjectFind("pivot"+Time[Li_80+1]) == -1) {
               Li_10 = SDSHISHL(Gi_164, Li_0);
               if (Li_10 == 1) {
                  ObjectCreate("pivot"+Time[Li_80+1],OBJ_ARROW,0,Time[Li_80+1],High[Li_80+1] + Point * 20);
                  ObjectSet("pivot"+Time[Li_80+1],OBJPROP_ARROWCODE,159);
                  ObjectSet("pivot"+Time[Li_80+1],OBJPROP_COLOR,Yellow);
                  ObjectSet("pivot"+Time[Li_80],OBJPROP_WIDTH,4);
               }
               if (Li_10 == -1) {
                  ObjectCreate("pivot"+Time[Li_80+1],OBJ_ARROW,0,Time[Li_80+1],Low[Li_80+1] + Point * 10);
                  ObjectSet("pivot"+Time[Li_80+1],OBJPROP_ARROWCODE,159);
                  ObjectSet("pivot"+Time[Li_80+1],OBJPROP_COLOR,Yellow);
                  ObjectSet("pivot"+Time[Li_80],OBJPROP_WIDTH,4);
               }
            }
         }
         if (ObjectFind("pbar"+Time[Li_80]) == -1) {
            Li_4 = SDSHV(Gi_164, Li_0);
            Li_6 = SDSHWB(Gi_164, Li_0);
            if (WideBars == ON) {
               if (Li_4 == 1 && Li_6 == 0) { objectcolor = Green; objectwidth = 3; }
               if (Li_4 == 1 && Li_6 == 1) { objectcolor = Lime; objectwidth = 4; }
               if (Li_4 == 0 && Li_6 == 0) { objectcolor = White; objectwidth = 3; }
               if (Li_4 == 0 && Li_6 == 1) { objectcolor = Yellow; objectwidth = 4; }
               if (Li_4 == -1 && Li_6 == 0) { objectcolor = FireBrick; objectwidth = 3; }
               if (Li_4 == -1 && Li_6 == 1) { objectcolor = Red; objectwidth = 4; }
            } else {
               if (Li_4 == 1) { objectcolor = Green; objectwidth = 3; }
               if (Li_4 == 0) { objectcolor = White; objectwidth = 3; }
               if (Li_4 == -1) { objectcolor = Red; objectwidth = 3; }
            }
            ObjectCreate("pbar"+Time[Li_80],OBJ_RECTANGLE,0,Time[Li_80],High[Li_80],Time[Li_80],Low[Li_80]);
            ObjectSet("pbar"+Time[Li_80],OBJPROP_STYLE,STYLE_SOLID);
            ObjectSet("pbar"+Time[Li_80],OBJPROP_WIDTH,objectwidth);
            ObjectSet("pbar"+Time[Li_80],OBJPROP_COLOR,objectcolor);
            ObjectSet("pbar"+Time[Li_80], OBJPROP_BACK, false); 
         }
      }
      if (Stop_Alerts == ON) {
         if (Li_76 == 2) {
            if (G_ibuf_160[1] != EMPTY_VALUE && G_ibuf_160[2] == EMPTY_VALUE) Alert("SDI Barrier has turned Red: ", Symbol(), "-", Gs_168);
            if (G_ibuf_156[1] != EMPTY_VALUE && G_ibuf_156[2] == EMPTY_VALUE) Alert("SDIBarrier has turned Green: ", Symbol(), "-", Gs_168);
         }
      }
      if (Trend_Alerts == ON) {
         if (Li_76 == 2) {
            if (G_ibuf_136[1] != EMPTY_VALUE && G_ibuf_136[2] == EMPTY_VALUE) Alert("SDI Trend has turned Green: ", Symbol(), "-", Gs_168);
            if (G_ibuf_140[1] != EMPTY_VALUE && G_ibuf_140[2] == EMPTY_VALUE) Alert("SDI Trend has turned Red: ", Symbol(), "-", Gs_168);
         }
      }
      if (Li_76 == 2) Gd_176 = Ld_20;

      if (lastmtfbar == iTime(Symbol(),HigherTrendPeriod,0)) {
         G_ibuf_156[1] = G_ibuf_156[2];
         G_ibuf_160[1] = G_ibuf_160[2];
         ChartRedraw(0);
         return(0);
      }

int shift,y;
trendspeed = 1.25;
trendmodifier = 2.25;

      for (int Li_12 = 200 / timeframedivider; Li_12 > 0; Li_12--) {
         SDSAddPriceData(Gi_100, iOpen(Symbol(),HigherTrendPeriod,Li_12), iHigh(Symbol(),HigherTrendPeriod,Li_12), iLow(Symbol(),HigherTrendPeriod,Li_12), iClose(Symbol(),HigherTrendPeriod,Li_12), iVolume(Symbol(),HigherTrendPeriod,Li_12), iTime(Symbol(),HigherTrendPeriod,Li_12), HigherTrendPeriod, HigherTrendPeriod, 2, Point, 200 / timeframedivider - Li_12);

         if (Stops == ON) {
            Ld_20 = SDSHSB(Gi_100, Li_0, trendspeed, trendmodifier, trendspeed);
            Ld_52 = SDSHSBFSV(Gi_100, Li_0, trendspeed, trendmodifier, trendspeed);

            shift = iBarShift(Symbol(),Period(),iTime(Symbol(),HigherTrendPeriod,Li_12));

            for (y = shift; y > shift - timeframedivider && y > 0; y--) {      
               if (Ld_20 == 1.0) G_ibuf_156[y] = Ld_52;
               if (Ld_20 == -1.0) G_ibuf_160[y] = Ld_52;
            }
         }
      }

      for (;y>0;y--) {                 
         G_ibuf_156[y] = G_ibuf_156[y-1];
         G_ibuf_160[y] = G_ibuf_160[y-1];
      }

   lastmtfbar = iTime(Symbol(),HigherTrendPeriod,0);
 
 
   ChartRedraw();
   return(0);
}
   ChartRedraw();
   return(0);

}
int sessionInit()
  {
   if(Digits==3 || Digits==5)vPoint = Point*10; else vPoint = Point;
   
   Qty = stringExtract_(SessionNames,"/",saName);  
         stringExtract_(SessionBegins,"/",saBeg);  
         stringExtract_(SessionEnds,"/",saEnd);  
         if(Qty>5)Qty = 5; 
         
   ArrayResize(lo,Qty); ArrayInitialize(lo,99999999.0);
   ArrayResize(hi,Qty); ArrayInitialize(hi,0.0);
   ArrayResize(t1,Qty);
   ArrayResize(t2,Qty);
   ArrayResize(pip,Qty);
   ArrayResize(col,Qty);
   ArrayResize(lastDate,Qty);

//   col[0] = color1; col[1] = color2; col[2] = color3; col[3] = color4; col[4] = color5;
   t0 = StrToTime(sTIME_BEGIN); curDate  = t0; 
   
   int g = 0;
   while(g<Qty){
   t1[g] = StrToTime(StringConcatenate(sTIME_BEGIN," ",saBeg[g]));  
   t2[g] = StrToTime(StringConcatenate(sTIME_BEGIN," ",saEnd[g])); 
   if(t1[g] > t2[g]) t2[g]+=86000;
   pip[g] = 0;
   lastDate[g] = t0; g++;
   }
   
   return(0);
  }

//+------------------------------------------------------------------+ 
int sessionDeinit()
  {
   int g; while(g<Qty){clear_(saName[g]); clear_(StringConcatenate("Pip",saName[g]));g++;} 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iterations                                      |
//+------------------------------------------------------------------+
int sessionStart()
  {
   int i, counted_bars = IndicatorCounted();
   if(counted_bars< 0) return(-1);
   if(counted_bars> 0) counted_bars--;
   int limit = Bars-1-counted_bars; 
   
   for(i=limit; i>=0; i--)
   {
      curDate = stripToDate_(Time[i]); int g = 0;
      while(g<Qty){
      Session_(saName, curDate, lastDate, t1, t2, lo, hi, pip, col[g], g, i); g++;
      }
   }  
   return(0);
  }
//+------------------------------------------------------------------+
void Session_(string & ses[], datetime cu, datetime & las[], datetime & t1[], datetime & t2[], 
              double & l1[], double & h1[], int & pip[], color col, int g, int i)
{
   if(Time[i] >= (cu+t1[g]) && Time[i] <= (cu+t2[g]))
   {
      if(cu > las[g]){
         las[g] = cu; l1[g] = Low[i]; h1[g] = High[i]; 
         pip[g] = (h1[g]-l1[g])/vPoint;
         createSes_(ses[g], cu, t1[g], l1[g], t2[g], h1[g], col);
         createPip_(ses[g], cu, t1[g], h1[g]);
         reDrawPip_(ses[g], cu, hi[g], pip[g]);
      }
      if(Low[i] < l1[g]){
         l1[g] = Low[i]; pip[g] = (h1[g]-l1[g])/vPoint;
         reDrawSes_(ses[g], cu, l1[g], h1[g]);
         reDrawPip_(ses[g], cu, hi[g], pip[g]);
      }
      if(High[i] > h1[g]){
         h1[g] = High[i]; pip[g] = (h1[g]-l1[g])/vPoint;
         reDrawSes_(ses[g], cu, l1[g], h1[g]);
         reDrawPip_(ses[g], cu, hi[g], pip[g]);
      }
   }
}
//+------------------------------------------------------------------+
void createSes_(string name, datetime cu_Date, datetime t1, double p1, datetime t2, double p2, color col)
{
   name = StringConcatenate(name, cu_Date);
   ObjectCreate(name, OBJ_RECTANGLE, 0, cu_Date + t1 , p1, cu_Date + t2 , p2);
   ObjectSet(name, OBJPROP_COLOR, col);
   ObjectSet(name, OBJPROP_BACK, FillColor); 
   ObjectSet(name, OBJPROP_STYLE, FrameStyle);
   ObjectSet(name, OBJPROP_WIDTH, FrameWidth);
}
//+------------------------------------------------------------------+
void reDrawSes_(string name, datetime cu_Date, double price1, double price2)
{
   name = StringConcatenate(name, cu_Date);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   ObjectSet(name, OBJPROP_PRICE2, price2);
}
//+------------------------------------------------------------------+ 
void createPip_(string name, datetime cu_Date, datetime t1, double p1)
{
   name = StringConcatenate("Pip", name, cu_Date);
   ObjectCreate(name, OBJ_TEXT, 0, cu_Date + t1 , p1);
}
//+------------------------------------------------------------------+
void reDrawPip_(string name, datetime cu_Date, double p1, int pip)
{
   string displayname = name;
   name = StringConcatenate("Pip", name, cu_Date);
   ObjectSetText(name, StringConcatenate("                    ",displayname," ", pip, " pips"), 
   LabelSize, LabelFont, LabelColor);
   ObjectSet(name, OBJPROP_PRICE1, p1);
}

//+------------------------------------------------------------------+
int stringExtract_(string toRead, string delimChar, string& ReadValue[]) 
{
   int delimPos[]; int len=StringLen(toRead); int curpos; Qty=0;
   ArrayResize(delimPos,len); ArrayInitialize(delimPos,  0);
   ArrayResize(ReadValue,len); // ArrayInitialize(ReadValue,"");
   for(curpos=0; curpos<=len;)
   { 
      delimPos[Qty]=curpos-1;
      curpos = StringFind(toRead,delimChar,curpos)+1;
      if(curpos<=0) break; Qty++; 
   }
   if(Qty==0)ReadValue[0]=toRead; else
   for (int j=0; j<=Qty; j++)
      ReadValue[j] = StringSubstr(toRead,delimPos[j]+1,(delimPos[j+1]-delimPos[j])-1); 
   return(Qty+1);
}
//+------------------------------------------------------------------+
datetime stripToDate_( datetime aTime )  
{                                           
   aTime -= MathMod(aTime,86400);        
   return(aTime);                        
}
//+------------------------------------------------------------------+
void clear_(string prefix) {
int prefix_len = StringLen(prefix);
   for(int i=ObjectsTotal(); i>=0; i--)
   {      
     string name = ObjectName(i);
        if (StringSubstr(name,0,prefix_len) == prefix) ObjectDelete(name);
   }    
}
//+------------------------------------------------------------------+
void nextBar() {

int minNextBar,secNextBar;
double itemp;

   minNextBar=Time[0]+Period()*60-TimeCurrent();
   itemp=minNextBar/60.0;
   secNextBar=minNextBar%60;
   minNextBar=(minNextBar-minNextBar%60)/60;

   ObjectSetText("BarTime","<- "+minNextBar+":"+secNextBar, 10, "Tahoma" ,Yellow);
   ObjectMove("BarTime",0,Time[0]+Period()*NextBarTimeOffset,Ask);  
}

int supresInit() {
   return (0);
}

int supresDeinit() {
   ObjectDelete("PivotLine");
   ObjectDelete("R1_Line");
   ObjectDelete("R2_Line");
   ObjectDelete("R3_Line");
   ObjectDelete("S1_Line");
   ObjectDelete("S2_Line");
   ObjectDelete("S3_Line");
   ObjectDelete("DM1_Line");
   ObjectDelete("DM2_Line");
   ObjectDelete("DM3_Line");
   ObjectDelete("DM4_Line");
   ObjectDelete("DM5_Line");
   ObjectDelete("DM6_Line");
   ObjectDelete("PivotLabel");
   ObjectDelete("R1_Label");
   ObjectDelete("R2_Label");
   ObjectDelete("R3_Label");
   ObjectDelete("S1_Label");
   ObjectDelete("S2_Label");
   ObjectDelete("S3_Label");
   ObjectDelete("DM1_Label");
   ObjectDelete("DM2_Label");
   ObjectDelete("DM3_Label");
   ObjectDelete("DM4_Label");
   ObjectDelete("DM5_Label");
   ObjectDelete("DM6_Label");
   ObjectDelete("WeekPivotLine");
   ObjectDelete("WR1_Line");
   ObjectDelete("WR2_Line");
   ObjectDelete("WR3_Line");
   ObjectDelete("WS1_Line");
   ObjectDelete("WS2_Line");
   ObjectDelete("WS3_Line");
   ObjectDelete("WM1_Line");
   ObjectDelete("WM2_Line");
   ObjectDelete("WM3_Line");
   ObjectDelete("WM4_Line");
   ObjectDelete("WM5_Line");
   ObjectDelete("WM6_Line");
   ObjectDelete("WeekPivotLabel");
   ObjectDelete("WR1_Label");
   ObjectDelete("WR2_Label");
   ObjectDelete("WR3_Label");
   ObjectDelete("WS1_Label");
   ObjectDelete("WS2_Label");
   ObjectDelete("WS3_Label");
   ObjectDelete("WM1_Label");
   ObjectDelete("WM2_Label");
   ObjectDelete("WM3_Label");
   ObjectDelete("WM4_Label");
   ObjectDelete("WM5_Label");
   ObjectDelete("WM6_Label");
   ObjectDelete("MonthPivotLine");
   ObjectDelete("MR1_Line");
   ObjectDelete("MR2_Line");
   ObjectDelete("MR3_Line");
   ObjectDelete("MS1_Line");
   ObjectDelete("MS2_Line");
   ObjectDelete("MS3_Line");
   ObjectDelete("MM1_Line");
   ObjectDelete("MM2_Line");
   ObjectDelete("MM3_Line");
   ObjectDelete("MM4_Line");
   ObjectDelete("MM5_Line");
   ObjectDelete("MM6_Line");
   ObjectDelete("MonthPivotLabel");
   ObjectDelete("MR1_Label");
   ObjectDelete("MR2_Label");
   ObjectDelete("MR3_Label");
   ObjectDelete("MS1_Label");
   ObjectDelete("MS2_Label");
   ObjectDelete("MS3_Label");
   ObjectDelete("MM1_Label");
   ObjectDelete("MM2_Label");
   ObjectDelete("MM3_Label");
   ObjectDelete("MM4_Label");
   ObjectDelete("MM5_Label");
   ObjectDelete("MM6_Label");
   return (0);
}

int supresStart() {
   ArrayCopyRates(Gda_188, Symbol(), PERIOD_D1);
   Gd_164 = Gda_188[1][3];
   Gd_172 = Gda_188[1][2];
   Gd_180 = Gda_188[1][4];
   G_price_192 = (Gd_164 + Gd_172 + Gd_180) / 3.0;
   G_price_224 = 2.0 * G_price_192 - Gd_172;
   G_price_200 = 2.0 * G_price_192 - Gd_164;
   G_price_232 = G_price_192 + (G_price_224 - G_price_200);
   G_price_208 = G_price_192 - (G_price_224 - G_price_200);
   G_price_240 = Gd_164 + 2.0 * (G_price_192 - Gd_172);
   G_price_216 = Gd_172 - 2.0 * (Gd_164 - G_price_192);
   G_price_248 = G_price_216 + (G_price_208 - G_price_216) / 2.0;
   G_price_256 = G_price_208 + (G_price_200 - G_price_208) / 2.0;
   G_price_264 = G_price_200 + (G_price_192 - G_price_200) / 2.0;
   G_price_272 = G_price_192 + (G_price_224 - G_price_192) / 2.0;
   G_price_280 = G_price_224 + (G_price_232 - G_price_224) / 2.0;
   G_price_288 = G_price_232 + (G_price_240 - G_price_232) / 2.0;
   if (Use_Sunday_Data == FALSE) {
      Comment("Sunday Bar ignored", "");
      if (DayOfWeek() == 1) {
         Gd_164 = Gda_188[2][3];
         Gd_172 = Gda_188[2][2];
         Gd_180 = Gda_188[2][4];
         G_price_192 = (Gd_164 + Gd_172 + Gd_180) / 3.0;
         G_price_224 = 2.0 * G_price_192 - Gd_172;
         G_price_200 = 2.0 * G_price_192 - Gd_164;
         G_price_232 = G_price_192 + (G_price_224 - G_price_200);
         G_price_208 = G_price_192 - (G_price_224 - G_price_200);
         G_price_240 = Gd_164 + 2.0 * (G_price_192 - Gd_172);
         G_price_216 = Gd_172 - 2.0 * (Gd_164 - G_price_192);
         G_price_248 = G_price_216 + (G_price_208 - G_price_216) / 2.0;
         G_price_256 = G_price_208 + (G_price_200 - G_price_208) / 2.0;
         G_price_264 = G_price_200 + (G_price_192 - G_price_200) / 2.0;
         G_price_272 = G_price_192 + (G_price_224 - G_price_192) / 2.0;
         G_price_280 = G_price_224 + (G_price_232 - G_price_224) / 2.0;
         G_price_288 = G_price_232 + (G_price_240 - G_price_232) / 2.0;
      }
   }
   ArrayCopyRates(Gda_320, Symbol(), PERIOD_W1);
   Gd_296 = Gda_320[1][3];
   Gd_304 = Gda_320[1][2];
   Gd_312 = Gda_320[1][4];
   G_price_324 = (Gd_296 + Gd_304 + Gd_312) / 3.0;
   G_price_356 = 2.0 * G_price_324 - Gd_304;
   G_price_332 = 2.0 * G_price_324 - Gd_296;
   G_price_364 = G_price_324 + (G_price_356 - G_price_332);
   G_price_340 = G_price_324 - (G_price_356 - G_price_332);
   G_price_348 = Gd_304 - 2.0 * (Gd_296 - G_price_324);
   G_price_372 = Gd_296 + 2.0 * (G_price_324 - Gd_304);
   G_price_380 = G_price_348 + (G_price_340 - G_price_348) / 2.0;
   G_price_388 = G_price_340 + (G_price_332 - G_price_340) / 2.0;
   G_price_396 = G_price_332 + (G_price_324 - G_price_332) / 2.0;
   G_price_404 = G_price_324 + (G_price_356 - G_price_324) / 2.0;
   G_price_412 = G_price_356 + (G_price_364 - G_price_356) / 2.0;
   G_price_420 = G_price_364 + (G_price_372 - G_price_364) / 2.0;
   ArrayCopyRates(Gda_452, Symbol(), PERIOD_MN1);
   Gd_428 = Gda_452[1][3];
   Gd_436 = Gda_452[1][2];
   Gd_444 = Gda_452[1][4];
   G_price_456 = (Gd_428 + Gd_436 + Gd_444) / 3.0;
   G_price_488 = 2.0 * G_price_456 - Gd_436;
   G_price_464 = 2.0 * G_price_456 - Gd_428;
   G_price_496 = G_price_456 + (G_price_488 - G_price_464);
   G_price_472 = G_price_456 - (G_price_488 - G_price_464);
   G_price_480 = Gd_436 - 2.0 * (Gd_428 - G_price_456);
   G_price_504 = Gd_428 + 2.0 * (G_price_456 - Gd_436);
   G_price_512 = G_price_480 + (G_price_472 - G_price_480) / 2.0;
   G_price_520 = G_price_472 + (G_price_464 - G_price_472) / 2.0;
   G_price_528 = G_price_464 + (G_price_456 - G_price_464) / 2.0;
   G_price_536 = G_price_456 + (G_price_488 - G_price_456) / 2.0;
   G_price_544 = G_price_488 + (G_price_496 - G_price_488) / 2.0;
   G_price_552 = G_price_496 + (G_price_504 - G_price_496) / 2.0;
   if (Daily == TRUE) {
      TimeToStr(TimeCurrent());
      if (ObjectFind("PivotLine") != 0) {
         ObjectCreate("PivotLine", OBJ_HLINE, 0, TimeCurrent(), G_price_192);
         ObjectSet("PivotLine", OBJPROP_COLOR, Daily_Pivot);
         ObjectSet("PivotLine", OBJPROP_STYLE, STYLE_DASH);
      } else ObjectMove("PivotLine", 0, Time[20], G_price_192);
      if (ObjectFind("PivotLabel") != 0) {
         ObjectCreate("PivotLabel", OBJ_TEXT, 0, Time[20], G_price_192);
         ObjectSetText("PivotLabel", "Daily Pivot", 8, "Arial", Daily_Pivot);
      } else ObjectMove("PivotLabel", 0, Time[20], G_price_192);
      WindowRedraw();
      if (Daily_SR_Levels == TRUE) {
         if (ObjectFind("R1_Line") != 0) {
            ObjectCreate("R1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_224);
            ObjectSet("R1_Line", OBJPROP_COLOR, Daily_R_Levels);
            ObjectSet("R1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("R1_Line", 0, Time[20], G_price_224);
         if (ObjectFind("R1_Label") != 0) {
            ObjectCreate("R1_Label", OBJ_TEXT, 0, Time[20], G_price_224);
            ObjectSetText("R1_Label", "Daily R1", 8, "Arial", Daily_R_Levels);
         } else ObjectMove("R1_Label", 0, Time[20], G_price_224);
         if (ObjectFind("R2_Line") != 0) {
            ObjectCreate("R2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_232);
            ObjectSet("R2_Line", OBJPROP_COLOR, Daily_R_Levels);
            ObjectSet("R2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("R2_Line", 0, Time[20], G_price_232);
         if (ObjectFind("R2_Label") != 0) {
            ObjectCreate("R2_Label", OBJ_TEXT, 0, Time[20], G_price_232);
            ObjectSetText("R2_Label", "Daily R2", 8, "Arial", Daily_R_Levels);
         } else ObjectMove("R2_Label", 0, Time[20], G_price_232);
         if (ObjectFind("R3_Line") != 0) {
            ObjectCreate("R3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_240);
            ObjectSet("R3_Line", OBJPROP_COLOR, Daily_R_Levels);
            ObjectSet("R3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("R3_Line", 0, Time[20], G_price_240);
         if (ObjectFind("R3_Label") != 0) {
            ObjectCreate("R3_Label", OBJ_TEXT, 0, Time[20], G_price_240);
            ObjectSetText("R3_Label", "Daily R3", 8, "Arial", Daily_R_Levels);
         } else ObjectMove("R3_Label", 0, Time[20], G_price_240);
         if (ObjectFind("S1_Line") != 0) {
            ObjectCreate("S1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_200);
            ObjectSet("S1_Line", OBJPROP_COLOR, Daily_S_Levels);
            ObjectSet("S1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("S1_Line", 0, Time[20], G_price_200);
         if (ObjectFind("S1_Label") != 0) {
            ObjectCreate("S1_Label", OBJ_TEXT, 0, Time[20], G_price_200);
            ObjectSetText("S1_Label", "Daily S1", 8, "Arial", Daily_S_Levels);
         } else ObjectMove("S1_Label", 0, Time[20], G_price_200);
         if (ObjectFind("S2_Line") != 0) {
            ObjectCreate("S2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_208);
            ObjectSet("S2_Line", OBJPROP_COLOR, Daily_S_Levels);
            ObjectSet("S2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("S2_Line", 0, Time[20], G_price_208);
         if (ObjectFind("S2_Label") != 0) {
            ObjectCreate("S2_Label", OBJ_TEXT, 0, Time[20], G_price_208);
            ObjectSetText("S2_Label", "Daily S2", 8, "Arial", Daily_S_Levels);
         } else ObjectMove("S2_Label", 0, Time[20], G_price_208);
         if (ObjectFind("S3_Line") != 0) {
            ObjectCreate("S3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_216);
            ObjectSet("S3_Line", OBJPROP_COLOR, Daily_S_Levels);
            ObjectSet("S3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("S3_Line", 0, Time[20], G_price_216);
         if (ObjectFind("S3_Label") != 0) {
            ObjectCreate("S3_Label", OBJ_TEXT, 0, Time[20], G_price_216);
            ObjectSetText("S3_Label", "Daily S3", 8, "Arial", Daily_S_Levels);
         } else ObjectMove("S3_Label", 0, Time[20], G_price_216);
      }
      WindowRedraw();
   }
   if (Daily_Mid_Levels == TRUE) {
      if (ObjectFind("DM1_Line") != 0) {
         ObjectCreate("DM1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_248);
         ObjectSet("DM1_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM1_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM1_Line", 0, Time[15], G_price_248);
      if (ObjectFind("DM1_Label") != 0) {
         ObjectCreate("DM1_Label", OBJ_TEXT, 0, Time[15], G_price_248);
         ObjectSetText("DM1_Label", "DM1", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM1_Label", 0, Time[15], G_price_248);
      if (ObjectFind("DM2_Line") != 0) {
         ObjectCreate("DM2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_256);
         ObjectSet("DM2_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM2_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM2_Line", 0, Time[15], G_price_256);
      if (ObjectFind("DM2_Label") != 0) {
         ObjectCreate("DM2_Label", OBJ_TEXT, 0, Time[15], G_price_256);
         ObjectSetText("DM2_Label", "DM2", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM2_Label", 0, Time[15], G_price_256);
      if (ObjectFind("DM3_Line") != 0) {
         ObjectCreate("DM3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_264);
         ObjectSet("DM3_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM3_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM3_Line", 0, Time[15], G_price_264);
      if (ObjectFind("DM3_Label") != 0) {
         ObjectCreate("DM3_Label", OBJ_TEXT, 0, Time[15], G_price_264);
         ObjectSetText("DM3_Label", "DM3", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM3_Label", 0, Time[15], G_price_264);
      if (ObjectFind("DM4_Line") != 0) {
         ObjectCreate("DM4_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_272);
         ObjectSet("DM4_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM4_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM4_Line", 0, Time[15], G_price_272);
      if (ObjectFind("DM4_Label") != 0) {
         ObjectCreate("DM4_Label", OBJ_TEXT, 0, Time[15], G_price_272);
         ObjectSetText("DM4_Label", "DM4", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM4_Label", 0, Time[15], G_price_272);
      if (ObjectFind("DM5_Line") != 0) {
         ObjectCreate("DM5_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_280);
         ObjectSet("DM5_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM5_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM5_Line", 0, Time[15], G_price_280);
      if (ObjectFind("DM5_Label") != 0) {
         ObjectCreate("DM5_Label", OBJ_TEXT, 0, Time[15], G_price_280);
         ObjectSetText("DM5_Label", "DM5", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM5_Label", 0, Time[15], G_price_280);
      if (ObjectFind("DM6_Line") != 0) {
         ObjectCreate("DM6_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_288);
         ObjectSet("DM6_Line", OBJPROP_COLOR, Daily_Mid_Level);
         ObjectSet("DM6_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("DM6_Line", 0, Time[15], G_price_288);
      if (ObjectFind("DM6_Label") != 0) {
         ObjectCreate("DM6_Label", OBJ_TEXT, 0, Time[15], G_price_288);
         ObjectSetText("DM6_Label", "DM6", 8, "Arial", Daily_Mid_Level);
      } else ObjectMove("DM6_Label", 0, Time[15], G_price_288);
      WindowRedraw();
   }
   if (Weekly == TRUE) {
      if (ObjectFind("WeekPivotLine") != 0) {
         ObjectCreate("WeekPivotLine", OBJ_HLINE, 0, TimeCurrent(), G_price_324);
         ObjectSet("WeekPivotLine", OBJPROP_COLOR, Weekly_Pivot);
         ObjectSet("WeekPivotLine", OBJPROP_STYLE, STYLE_DASH);
      } else ObjectMove("WeekPivotLine", 0, Time[30], G_price_324);
      if (ObjectFind("WeekPivotLabel") != 0) {
         ObjectCreate("WeekPivotLabel", OBJ_TEXT, 0, Time[30], G_price_324);
         ObjectSetText("WeekPivotLabel", "WeeklyPivot", 8, "Arial", Weekly_Pivot);
      } else ObjectMove("WeekPivotLabel", 0, Time[30], G_price_324);
      if (Weekly_SR_Levels == TRUE) {
         if (ObjectFind("WR1_Line") != 0) {
            ObjectCreate("WR1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_356);
            ObjectSet("WR1_Line", OBJPROP_COLOR, Weekly_R_Levels);
            ObjectSet("WR1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WR1_Line", 0, Time[30], G_price_356);
         if (ObjectFind("WR1_Label") != 0) {
            ObjectCreate("WR1_Label", OBJ_TEXT, 0, Time[30], G_price_356);
            ObjectSetText("WR1_Label", " Weekly R1", 8, "Arial", Weekly_R_Levels);
         } else ObjectMove("WR1_Label", 0, Time[30], G_price_356);
         if (ObjectFind("WR2_Line") != 0) {
            ObjectCreate("WR2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_364);
            ObjectSet("WR2_Line", OBJPROP_COLOR, Weekly_R_Levels);
            ObjectSet("WR2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WR2_Line", 0, Time[30], G_price_364);
         if (ObjectFind("WR2_Label") != 0) {
            ObjectCreate("WR2_Label", OBJ_TEXT, 0, Time[30], G_price_364);
            ObjectSetText("WR2_Label", " Weekly R2", 8, "Arial", Weekly_R_Levels);
         } else ObjectMove("WR2_Label", 0, Time[30], G_price_364);
         if (ObjectFind("WR3_Line") != 0) {
            ObjectCreate("WR3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_372);
            ObjectSet("WR3_Line", OBJPROP_COLOR, Weekly_R_Levels);
            ObjectSet("WR3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WR3_Line", 0, Time[30], G_price_372);
         if (ObjectFind("WR3_Label") != 0) {
            ObjectCreate("WR3_Label", OBJ_TEXT, 0, Time[30], G_price_372);
            ObjectSetText("WR3_Label", " Weekly R3", 8, "Arial", Weekly_R_Levels);
         } else ObjectMove("WR3_Label", 0, Time[30], G_price_372);
         if (ObjectFind("WS1_Line") != 0) {
            ObjectCreate("WS1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_332);
            ObjectSet("WS1_Line", OBJPROP_COLOR, Weekly_S_Levels);
            ObjectSet("WS1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WS1_Line", 0, Time[30], G_price_332);
         if (ObjectFind("WS1_Label") != 0) {
            ObjectCreate("WS1_Label", OBJ_TEXT, 0, Time[30], G_price_332);
            ObjectSetText("WS1_Label", "Weekly S1", 8, "Arial", Weekly_S_Levels);
         } else ObjectMove("WS1_Label", 0, Time[30], G_price_332);
         if (ObjectFind("WS2_Line") != 0) {
            ObjectCreate("WS2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_340);
            ObjectSet("WS2_Line", OBJPROP_COLOR, Weekly_S_Levels);
            ObjectSet("WS2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WS2_Line", 0, Time[30], G_price_340);
         if (ObjectFind("WS2_Label") != 0) {
            ObjectCreate("WS2_Label", OBJ_TEXT, 0, Time[30], G_price_340);
            ObjectSetText("WS2_Label", "Weekly S2", 8, "Arial", Weekly_S_Levels);
         } else ObjectMove("WS2_Label", 0, Time[30], G_price_340);
         if (ObjectFind("WS3_Line") != 0) {
            ObjectCreate("WS3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_348);
            ObjectSet("WS3_Line", OBJPROP_COLOR, Weekly_S_Levels);
            ObjectSet("WS3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("WS3_Line", 0, Time[30], G_price_348);
         if (ObjectFind("WS3_Label") != 0) {
            ObjectCreate("WS3_Label", OBJ_TEXT, 0, Time[30], G_price_348);
            ObjectSetText("WS3_Label", "Weekly S3", 8, "Arial", Weekly_S_Levels);
         } else ObjectMove("WS3_Label", 0, Time[30], G_price_348);
      }
   }
   if (Weekly_Mid_Levels == TRUE) {
      if (ObjectFind("WM1_Line") != 0) {
         ObjectCreate("WM1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_380);
         ObjectSet("WM1_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM1_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM1_Line", 0, Time[25], G_price_380);
      if (ObjectFind("WM1_Label") != 0) {
         ObjectCreate("WM1_Label", OBJ_TEXT, 0, Time[25], G_price_380);
         ObjectSetText("WM1_Label", "WM1", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM1_Label", 0, Time[25], G_price_380);
      if (ObjectFind("WM2_Line") != 0) {
         ObjectCreate("WM2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_388);
         ObjectSet("WM2_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM2_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM2_Line", 0, Time[25], G_price_388);
      if (ObjectFind("WM2_Label") != 0) {
         ObjectCreate("WM2_Label", OBJ_TEXT, 0, Time[25], G_price_388);
         ObjectSetText("WM2_Label", "WM2", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM2_Label", 0, Time[25], G_price_388);
      if (ObjectFind("WM3_Line") != 0) {
         ObjectCreate("WM3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_396);
         ObjectSet("WM3_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM3_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM3_Line", 0, Time[25], G_price_396);
      if (ObjectFind("WM3_Label") != 0) {
         ObjectCreate("WM3_Label", OBJ_TEXT, 0, Time[25], G_price_396);
         ObjectSetText("WM3_Label", "WM3", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM3_Label", 0, Time[25], G_price_396);
      if (ObjectFind("WM4_Line") != 0) {
         ObjectCreate("WM4_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_404);
         ObjectSet("WM4_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM4_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM4_Line", 0, Time[25], G_price_404);
      if (ObjectFind("WM4_Label") != 0) {
         ObjectCreate("WM4_Label", OBJ_TEXT, 0, Time[25], G_price_404);
         ObjectSetText("WM4_Label", "WM4", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM4_Label", 0, Time[25], G_price_404);
      if (ObjectFind("WM5_Line") != 0) {
         ObjectCreate("WM5_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_412);
         ObjectSet("WM5_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM5_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM5_Line", 0, Time[25], G_price_412);
      if (ObjectFind("WM5_Label") != 0) {
         ObjectCreate("WM5_Label", OBJ_TEXT, 0, Time[25], G_price_412);
         ObjectSetText("WM5_Label", "WM5", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM5_Label", 0, Time[25], G_price_412);
      if (ObjectFind("WM6_Line") != 0) {
         ObjectCreate("WM6_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_420);
         ObjectSet("WM6_Line", OBJPROP_COLOR, Weekly_Mid_Level);
         ObjectSet("WM6_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("WM6_Line", 0, Time[25], G_price_420);
      if (ObjectFind("WM6_Label") != 0) {
         ObjectCreate("WM6_Label", OBJ_TEXT, 0, Time[25], G_price_420);
         ObjectSetText("WM6_Label", "WM6", 8, "Arial", Weekly_Mid_Level);
      } else ObjectMove("WM6_Label", 0, Time[25], G_price_420);
      WindowRedraw();
   }
   if (Monthly == TRUE) {
      if (ObjectFind("MonthPivotLine") != 0) {
         ObjectCreate("MonthPivotLine", OBJ_HLINE, 0, TimeCurrent(), G_price_456);
         ObjectSet("MonthPivotLine", OBJPROP_COLOR, Monthly_Pivot);
         ObjectSet("MonthPivotLine", OBJPROP_STYLE, STYLE_DASH);
      } else ObjectMove("MonthPivotLine", 0, Time[40], G_price_456);
      if (ObjectFind("MonthPivotLabel") != 0) {
         ObjectCreate("MonthPivotLabel", OBJ_TEXT, 0, Time[40], G_price_456);
         ObjectSetText("MonthPivotLabel", "MonthlyPivot", 8, "Arial", Monthly_Pivot);
      } else ObjectMove("MonthPivotLabel", 0, Time[40], G_price_456);
      if (Monthly_SR_Levels == TRUE) {
         if (ObjectFind("MR1_Line") != 0) {
            ObjectCreate("MR1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_488);
            ObjectSet("MR1_Line", OBJPROP_COLOR, Monthly_R_Levels);
            ObjectSet("MR1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MR1_Line", 0, Time[40], G_price_488);
         if (ObjectFind("MR1_Label") != 0) {
            ObjectCreate("MR1_Label", OBJ_TEXT, 0, Time[40], G_price_488);
            ObjectSetText("MR1_Label", " Monthly R1", 8, "Arial", Monthly_R_Levels);
         } else ObjectMove("MR1_Label", 0, Time[40], G_price_488);
         if (ObjectFind("MR2_Line") != 0) {
            ObjectCreate("MR2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_496);
            ObjectSet("MR2_Line", OBJPROP_COLOR, Monthly_R_Levels);
            ObjectSet("MR2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MR2_Line", 0, Time[40], G_price_496);
         if (ObjectFind("MR2_Label") != 0) {
            ObjectCreate("MR2_Label", OBJ_TEXT, 0, Time[40], G_price_496);
            ObjectSetText("MR2_Label", " Monthly R2", 8, "Arial", Monthly_R_Levels);
         } else ObjectMove("MR2_Label", 0, Time[40], G_price_496);
         if (ObjectFind("MR3_Line") != 0) {
            ObjectCreate("MR3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_504);
            ObjectSet("MR3_Line", OBJPROP_COLOR, Monthly_R_Levels);
            ObjectSet("MR3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MR3_Line", 0, Time[40], G_price_504);
         if (ObjectFind("MR3_Label") != 0) {
            ObjectCreate("MR3_Label", OBJ_TEXT, 0, Time[40], G_price_504);
            ObjectSetText("MR3_Label", " Monthly R3", 8, "Arial", Monthly_R_Levels);
         } else ObjectMove("MR3_Label", 0, Time[40], G_price_504);
         if (ObjectFind("MS1_Line") != 0) {
            ObjectCreate("MS1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_464);
            ObjectSet("MS1_Line", OBJPROP_COLOR, Monthly_S_Levels);
            ObjectSet("MS1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MS1_Line", 0, Time[40], G_price_464);
         if (ObjectFind("MS1_Label") != 0) {
            ObjectCreate("MS1_Label", OBJ_TEXT, 0, Time[40], G_price_464);
            ObjectSetText("MS1_Label", "Monthly S1", 8, "Arial", Monthly_S_Levels);
         } else ObjectMove("MS1_Label", 0, Time[40], G_price_464);
         if (ObjectFind("MS2_Line") != 0) {
            ObjectCreate("MS2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_472);
            ObjectSet("MS2_Line", OBJPROP_COLOR, Monthly_S_Levels);
            ObjectSet("MS2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MS2_Line", 0, Time[40], G_price_472);
         if (ObjectFind("MS2_Label") != 0) {
            ObjectCreate("MS2_Label", OBJ_TEXT, 0, Time[40], G_price_472);
            ObjectSetText("MS2_Label", "Monthly S2", 8, "Arial", Monthly_S_Levels);
         } else ObjectMove("MS2_Label", 0, Time[40], G_price_472);
         if (ObjectFind("MS3_Line") != 0) {
            ObjectCreate("MS3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_480);
            ObjectSet("MS3_Line", OBJPROP_COLOR, Monthly_S_Levels);
            ObjectSet("MS3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
         } else ObjectMove("MS3_Line", 0, Time[40], G_price_480);
         if (ObjectFind("MS3_Label") != 0) {
            ObjectCreate("MS3_Label", OBJ_TEXT, 0, Time[40], G_price_480);
            ObjectSetText("MS3_Label", "Monthly S3", 8, "Arial", Monthly_S_Levels);
         } else ObjectMove("MS3_Label", 0, Time[40], G_price_480);
      }
   }
   if (Monthly_Mid_Levels == TRUE) {
      if (ObjectFind("MM1_Line") != 0) {
         ObjectCreate("MM1_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_512);
         ObjectSet("MM1_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM1_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM1_Line", 0, Time[35], G_price_512);
      if (ObjectFind("MM1_Label") != 0) {
         ObjectCreate("MM1_Label", OBJ_TEXT, 0, Time[35], G_price_512);
         ObjectSetText("MM1_Label", "MM1", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM1_Label", 0, Time[35], G_price_512);
      if (ObjectFind("MM2_Line") != 0) {
         ObjectCreate("MM2_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_520);
         ObjectSet("MM2_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM2_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM2_Line", 0, Time[35], G_price_520);
      if (ObjectFind("MM2_Label") != 0) {
         ObjectCreate("MM2_Label", OBJ_TEXT, 0, Time[35], G_price_520);
         ObjectSetText("MM2_Label", "MM2", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM2_Label", 0, Time[35], G_price_520);
      if (ObjectFind("MM3_Line") != 0) {
         ObjectCreate("MM3_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_528);
         ObjectSet("MM3_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM3_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM3_Line", 0, Time[35], G_price_528);
      if (ObjectFind("MM3_Label") != 0) {
         ObjectCreate("MM3_Label", OBJ_TEXT, 0, Time[35], G_price_528);
         ObjectSetText("MM3_Label", "MM3", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM3_Label", 0, Time[35], G_price_528);
      if (ObjectFind("MM4_Line") != 0) {
         ObjectCreate("MM4_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_536);
         ObjectSet("MM4_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM4_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM4_Line", 0, Time[35], G_price_536);
      if (ObjectFind("MM4_Label") != 0) {
         ObjectCreate("MM4_Label", OBJ_TEXT, 0, Time[35], G_price_536);
         ObjectSetText("MM4_Label", "MM4", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM4_Label", 0, Time[35], G_price_536);
      if (ObjectFind("MM5_Line") != 0) {
         ObjectCreate("MM5_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_544);
         ObjectSet("MM5_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM5_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM5_Line", 0, Time[25], G_price_544);
      if (ObjectFind("MM5_Label") != 0) {
         ObjectCreate("MM5_Label", OBJ_TEXT, 0, Time[35], G_price_544);
         ObjectSetText("MM5_Label", "MM5", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM5_Label", 0, Time[35], G_price_544);
      if (ObjectFind("MM6_Line") != 0) {
         ObjectCreate("MM6_Line", OBJ_HLINE, 0, TimeCurrent(), G_price_552);
         ObjectSet("MM6_Line", OBJPROP_COLOR, Monthly_Mid_Level);
         ObjectSet("MM6_Line", OBJPROP_STYLE, STYLE_DOT);
      } else ObjectMove("MM6_Line", 0, Time[35], G_price_552);
      if (ObjectFind("MM6_Label") != 0) {
         ObjectCreate("MM6_Label", OBJ_TEXT, 0, Time[35], G_price_552);
         ObjectSetText("MM6_Label", "MM6", 8, "Arial", Monthly_Mid_Level);
      } else ObjectMove("MM6_Label", 0, Time[35], G_price_552);
      WindowRedraw();
   }
   WindowRedraw();
   return (0);
}
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {

   if(id==CHARTEVENT_OBJECT_CLICK)
     {

      string clickedChartObject=ObjectGetString(0,sparam,OBJPROP_TEXT);
      string clickedObjectName = sparam;

      if (StringLen(clickedChartObject) == 6) {
            ChartSetSymbolPeriod(0,clickedChartObject,Period());
//         long newchartid = ChartOpen(clickedChartObject,Period());
//         ChartSetInteger(newchartid,CHART_HEIGHT_IN_PIXELS,0,800);
//         ChartSetInteger(newchartid,CHART_WIDTH_IN_PIXELS,0,1200);
//         ChartApplyTemplate(newchartid,"auto-trade-m15");
         return;
      }
      if (clickedChartObject == "Close") {
            ChartClose(0);
//         long newchartid = ChartOpen(clickedChartObject,Period());
//         ChartSetInteger(newchartid,CHART_HEIGHT_IN_PIXELS,0,800);
//         ChartSetInteger(newchartid,CHART_WIDTH_IN_PIXELS,0,1200);
//         ChartApplyTemplate(newchartid,"auto-trade-m15");
         return;
      }
      for (int i=0;i<9;i++) {
         if (clickedChartObject == butname[i]) {
            ChartSetSymbolPeriod(0,Symbol(),but[i]);
            return;
         }  
      }

  }
}
//+------------------------------------------------------------------+
void resizeWindow() {


int wndh = WindowHandle(Symbol(),Period());
   if (wndh == -1)
      return;
int wndhp = GetParent(wndh);
   if (wndhp == -1)
      return;

int wnds = GetWindowLongW(wndhp,GWL_STYLE);

   wnds &= ~(WS_CAPTION | WS_THICKFRAME | WS_MINIMIZE | WS_MAXIMIZE | WS_SYSMENU);
//   wnds &= WS_THINFRAME;

   SetWindowLongW(wndhp,GWL_STYLE,wnds);
   SetWindowPos(wndhp,NULL,0,0,0,0,SWP_NOZORDER|SWP_NOMOVE|SWP_NOSIZE|SWP_FRAMECHANGED);      
   SetWindowPos(wndhp,0,100,100,1400,800,SWP_NOZORDER);      
   
}